               JOB  HZG DEMO                                               SGSVU
               CTL  6611
     *
     * CONTROL CARD LAYOUT
     *
     I3LEN     EQU  4    1-4     TAPE 3 RECORD LENGTH
     I3WMAX    EQU  8    6-8     TAPE 3 RECORDS UNTIL REWIND
     I3PMAX    EQU  11   10-11   TAPE 3 PROCESSING DELAY
     I3RDLY    EQU  16   13-16   TAPE 3 REWIND DELAY
     I4LEN     EQU  21   18-21   TAPE 4 RECORD LENGTH
     I4WMAX    EQU  25   23-25   TAPE 4 RECORDS UNTIL REWIND
     I4PMAX    EQU  28   27-28   TAPE 4 PROCESSING DELAY
     I4RDLY    EQU  33   30-33   TAPE 4 REWIND DELAY
     I5LEN     EQU  38   35-38   TAPE 5 RECORD LENGTH
     I5WMAX    EQU  42   40-42   TAPE 5 RECORDS UNTIL REWIND
     I5PMAX    EQU  45   44-45   TAPE 5 PROCESSING DELAY
     I5RDLY    EQU  50   47-50   TAPE 5 REWIND DELAY
     I6LEN     EQU  55   52-55   TAPE 6 RECORD LENGTH
     I6WMAX    EQU  59   57-59   TAPE 6 RECORDS UNTIL REWIND
     I6PMAX    EQU  62   61-62   TAPE 6 PROCESSING DELAY
     I6RDLY    EQU  67   64-67   TAPE 6 REWIND DELAY
     IRDLY     EQU  72   69-72   FULL REEL TAPE REWIND DELAY
     IDDLY     EQU  75   74-75   DISK PROCESSING DELAY
     *
               ORG  81           RECORD MARK AT 81 WILL BE
               DC   @'.....@     SENTINEL AFTER LAST LINE OF IMAGE
     X1        DCW  081
               DC   @..@
     X2        DCW  010
               ORG  333
0333 START     CS   80
0337           SW   1
     *
     * LOAD PARAMETERS
     *
0341           R
0342           MCW  I3PMAX,T3PMAX      TAPE 3 PROCESSING DELAY
0349           MCW  I4PMAX,T4PMAX      TAPE 4 PROCESSING DELAY
0356           MCW  I5PMAX,T5PMAX      TAPE 5 PROCESSING DELAY
0363           MCW  I6PMAX,T6PMAX      TAPE 6 PROCESSING DELAY
0370           MCW  IDDLY,DCNTI        DISK DELAY COUNT
0377           MCW  I3WMAX,T3WMAX      TAPE 3 RECORDS UNTIL REWIND
0384           MCW  I4WMAX,T4WMAX      TAPE 4 RECORDS UNTIL REWIND
0391           MCW  I5WMAX,T5WMAX      TAPE 5 RECORDS UNTIL REWIND
0398           MCW  I6WMAX,T6WMAX      TAPE 6 RECORDS UNTIL REWIND 
0405           MCW  I3RDLY,T3RDLY      TAPE 3 REWIND DELAY
0412           MCW  I4RDLY,T4RDLY      TAPE 4 REWIND DELAY
0419           MCW  I5RDLY,T5RDLY      TAPE 5 REWIND DELAY
0426           MCW  I6RDLY,T6RDLY      TAPE 6 REWIND DELAY
0433           MCW  IRDLY,RDELAY       REWIND FULL TAPE DELAY COUNT
     *
     * CALCULATE TAPE WRITE ADDRESSES FROM RECORD LENGTHS
     *
0440           MCW  I3LEN,RLEN         STORE TAPE 3 RECORD LENGTH
0447           B    GETOFF             CALULATE OFFSET = - RLEN
0451           MA   ROFF,TAPE3W&6      SET TAPE 3 ADDRESS
0458           MCW  I4LEN,RLEN         STORE TAPE 4 RECORD LENGTH
0465           B    GETOFF             CALCULATE OFFSET = - RLEN
0469           MA   ROFF,TAPE4W&6      SET TAPE 4 ADDRESS
0476           MCW  I5LEN,RLEN         STORE TAPE 5 RECORD LENGTH
0483           B    GETOFF             CALCULATE OFFSET = - RLEN
0487           MA   ROFF,TAPE5W&6      SET TAPE 5 ADDRESS
0494           MCW  I6LEN,RLEN         STORE TAPE 6 RECORD LENGTH
0501           B    GETOFF             CALCULATE OFFSET = - RLEN
0505           MA   ROFF,TAPE6W&6      SET TAPE 6 ADDRESS
     *
     * READ THE IMAGE AND STORE IT.  THE FIRST CHARACTER AFTER THE LAST
     * ONE IN THE STORAGE AREA WILL BE A RECORD MARK.
     *
0512 RLOOP     R
0513           LCA  81,IMAGE&X1        STORE ONE LINE OF THE IMAGE
0520           B    GOTEM,A            DONE?
0525           MA   START&3,X1         ADD 80 TO X1
0532           B    RLOOP              GET ANOTHER ONE
     *
0536 GOTEM     MCW  START&3,X1         RESET X1 TO 80
0543           CS   332
0547           CS
0548           CC   1
0550           H                       WAIT FOR THE SWITCHES TO BE SET
     *
     * CHECK SWITCHES
     *
0551 SWLOOP    C    KZERO,KZERO
0558 PRNTSW    BSS  PRINT,C            CHANGED BY PRINT TO *BE*
0563           BSS  DISK,B
0568           BSS  TAPE3,D
0573           BSS  TAPE4,E
0578           BSS  TAPE5,F
0583           BSS  TAPE6,G
0588           B    SWLOOP
     *
     * CALCULATE THE OFFSET TO TAPE WRITE ADDRESSES, GIVEN THE
     * RECORD LENGTH IN RLEN
     *
0592 GETOFF    SBR  GETX&3
0596           LCA  P16K,ROFF          START WITH 16000
0603           S    RLEN,ROFF          DECREASE BY RECORD LENGTH   
0610           MZ   RLEN,ROFF          CLEAR ZONE
0617 GETL      C    KZERO,RTHOU        THOUSANDS DOWN TO ZERO?
0624 GETX      BE   0                  YES, DONE
0629           MA   K1000,ROFF         ADD 1000 TO OFFSET
0636           S    KP1,RTHOU          SUBTRACT ONE FROM THOUSANDS
0643           MZ   RLEN,RTHOU         CLEAR ZONE 
0650           B    GETL
     *
0654 RLEN      DCW  0000               RECORD LENGTH
0658 RTHOU     DCW  00                 THOUSANDS PART OF OFFSET
0660 ROFF      DC   000                OFFSET TO TAPE ADDRESS = - RLEN
0663 K1000     DSA  1000               ADDRESS CONSTANT 1000
     *
     * 1311 DISK EXERCISER
     *
0666 DISK      SBR  DISKX&3
0670           C    KONE,DCOUNT        IS THE COUNT ONE?
0677           BE   DISKA              YES, EXERCISE THE DISK
0682           S    KP1,DCOUNT         SUBTRACT ONE FROM THE COUNT
0689           MZ   KZERO,DCOUNT       CLEAR THE ZONE
0696           B    DISKX              GO TO SUBR EXIT
0700 DISKA     LCA  DK2,DMUL           A CRUDE MULTIPLICATIVE RNG
0707           M    DFAC,DPROD
0714           MCW  DPROD,DK2
0721           LCA  KONE,DADDR1
0728           MCW  DK1,DADDR1
0735           A    DADDR1
0739           MCW  KONE,DADDR2
0746           MCW  %F0,DADDR,R        SEEK DISK
0754           MCW  DCNTI,DCOUNT          
0761           B    DISKX              SKIP PRINTING DISK ADDRESSES
0765           MCW  DK1,200&X2         MOVE DISK ADDRESS TO PRINT AREA
0772           BCE  DISKW,X2-2,1       INDEX HIGH-ORDER DIGHT 1?
0780           B    DISKY              NO
0784 DISKW     W                       YES, WRITE THE ADDRESSES
0785           CS   332
0789           CS
0790           LCA  KZERO,X2           CLEAR INDEX
0797 DISKY     A    KTEN,X2            ADD TEN TO INDEX
0804 DISKX     B    0
     *
0808 DMUL      DCW  0000
     DPROD     DC   000
0815 DK1       DCW  91
     DK2       DC   57
0819 DFAC      DCW  83
     DADDR     DC   @*@
     DADDR1    DC   0000
     DADDR2    DC   00001
0831 KZERO     DCW  000                CONSTANT ZERO
0834 KONE      DCW  001
0837 KTEN      DCW  010
0840 DCNTI     DCW  00                 INITIAL DISK DELAY COUNT
0842 DCOUNT    DCW  01                 CURRENT DISK DELAY COUNT
     *
     * PRINT THE PICTURE
     *
0844 PRINT     SBR  PRINTX&3
0848           MCW  KS,PRNTSW&4        CHANGE ENTRY TEST TO BE
0855           LCA  IMAGE&X1,306
0862           W
0863           B    PRINTA,IMAGE&1&X1,'  LAST IMAGE?   
0871           MA   START&3,X1         ADD 80 TO X1
0878           B    PRINTX
0882 PRINTA    MCW  START&3,X1         RESET X1 TO 80
0889           CC   1
0891           MCW  KC,PRNTSW&4        CHANGE ENTRY TEST TO BSS C
0898 PRINTX    B    0
     *
     * TAPE 3 EXERCISE ROUTINE
     *
0902 TAPE3     SBR  TAPE3X&3
0906           BWZ  TAPE3A,T3RCNT,K    ENOUGH REWIND DELAY?
0914           S    KP1,T3RCNT
0921           B    TAPE3X
0925 TAPE3A    C    KONE,T3PCNT        ENOUGH PROCESSING DELAY?
0932           BE   TAPE3B
0937           S    KP1,T3PCNT         DECR PROCESSING DELAY COUNT
0944           MZ   KZERO,T3PCNT
0951           B    TAPE3X
0955 TAPE3B    LCA  T3RDLY,T3RCNT      RWD DELAY DEPENDING ON REC CNT
0962           BWZ  TAPE3E,T3WCNT,K    TIME TO REWIND?
0970           LCA  RDELAY,T3RCNT      DELAY FOR FULL REEL REWIND
0977           BEF  TAPE3E
0982           LCA  KM1,T3RCNT         SET FOR NO REWIND DELAY
0989 TAPE3W    MCW  %U3,GMWM,W
0997           S    KP1,T3WCNT         DECREMENT WRITE COUNTER
1004           MCW  T3PMAX,T3PCNT      STORE PROCESSING DELAY
1011 TAPE3X    B    0
1015 TAPE3E    CU   %U3,R
1020           MCW  T3WMAX,T3WCNT      RE-INITIALIZE WRITE COUNT
1027           B    TAPE3X
     *  
1031 T3PMAX    DCW  00
1033 T3PCNT    DCW  01
1035 T3WMAX    DCW  000                MAX RECORDS TO WRITE UNTIL REWIND
1038 T3WCNT    DCW  100                RECORDS TO WRITE UNTIL REWIND
1041 T3RDLY    DCW  0000               DELAY FOR REWIND
1045 T3RCNT    DCW  -0001              COUNT WHILE REWINDING
     *
     * TAPE 4 EXERCISE ROUTINE
     *
1049 TAPE4     SBR  TAPE4X&3
1053           BWZ  TAPE4A,T4RCNT,K    ENOUGH REWIND DELAY?
1061           S    KP1,T4RCNT
1068           B    TAPE4X
1072 TAPE4A    C    KONE,T4PCNT        ENOUGH PROCESSING DELAY?
1079           BE   TAPE4B
1084           S    KP1,T4PCNT         DECR PROCESSING DELAY COUNT
1091           MZ   KZERO,T4PCNT
1098           B    TAPE4X
1102 TAPE4B    LCA  T4RDLY,T4RCNT      RWD DELAY DEPENDING ON REC CNT
1109           BWZ  TAPE4E,T4WCNT,K    TIME TO REWIND?
1117           LCA  RDELAY,T4RCNT      DELAY FOR FULL REEL REWIND
1124           BEF  TAPE4E
1129           LCA  KM1,T4RCNT         SET FOR NO REWIND DELAY
1136 TAPE4W    MCW  %U4,GMWM,W
1144           S    KP1,T4WCNT         DECREMENT WRITE COUNTER
1151           MCW  T4PMAX,T4PCNT      STORE PROCESSING DELAY
1158 TAPE4X    B    0
1162 TAPE4E    CU   %U4,R
1167           MCW  T4WMAX,T4WCNT      RE-INITIALIZE WRITE COUNT
1174           B    TAPE4X
     *  
1178 T4PMAX    DCW  00
1180 T4PCNT    DCW  01
1182 T4WMAX    DCW  000                MAX RECORDS TO WRITE UNTIL REWIND
1185 T4WCNT    DCW  100                RECORDS TO WRITE UNTIL REWIND
1188 T4RDLY    DCW  0000               DELAY FOR REWIND
1192 T4RCNT    DCW  -0001              COUNT WHILE REWINDING
     *
     * TAPE 5 EXERCISE ROUTINE
     *
1196 TAPE5     SBR  TAPE5X&3
1200           BWZ  TAPE5A,T5RCNT,K    ENOUGH REWIND DELAY?
1208           S    KP1,T5RCNT
1215           B    TAPE5X
1219 TAPE5A    C    KONE,T5PCNT        ENOUGH PROCESSING DELAY?
1226           BE   TAPE5B
1231           S    KP1,T5PCNT         DECR PROCESSING DELAY COUNT
1238           MZ   KZERO,T5PCNT
1245           B    TAPE5X
1249 TAPE5B    LCA  T5RDLY,T5RCNT      RWD DELAY DEPENDING ON REC CNT
1256           BWZ  TAPE5E,T5WCNT,K    TIME TO REWIND?
1264           LCA  RDELAY,T5RCNT      DELAY FOR FULL REEL REWIND
1271           BEF  TAPE5E
1276           LCA  KM1,T5RCNT         SET FOR NO REWIND DELAY
1283 TAPE5W    MCW  %U5,GMWM,W
1291           S    KP1,T5WCNT         DECREMENT WRITE COUNTER
1298           MCW  T5PMAX,T5PCNT      STORE PROCESSING DELAY
1305 TAPE5X    B    0
1309 TAPE5E    CU   %U5,R
1314           MCW  T5WMAX,T5WCNT      RE-INITIALIZE WRITE COUNT
1321           B    TAPE5X
     *  
1325 T5PMAX    DCW  00
1327 T5PCNT    DCW  01
1329 T5WMAX    DCW  000                MAX RECORDS TO WRITE UNTIL REWIND
1332 T5WCNT    DCW  100                RECORDS TO WRITE UNTIL REWIND
1335 T5RDLY    DCW  0000               DELAY FOR REWIND
1339 T5RCNT    DCW  -0001              COUNT WHILE REWINDING
     *
     * TAPE 6 EXERCISE ROUTINE
     *
1343 TAPE6     SBR  TAPE6X&3
1347           BWZ  TAPE6A,T6RCNT,K    ENOUGH REWIND DELAY?
1355           S    KP1,T6RCNT
1362           B    TAPE6X
1366 TAPE6A    C    KONE,T6PCNT        ENOUGH PROCESSING DELAY?
1373           BE   TAPE6B
1378           S    KP1,T6PCNT         DECR PROCESSING DELAY COUNT
1385           MZ   KZERO,T6PCNT
1392           B    TAPE6X
1396 TAPE6B    LCA  T6RDLY,T6RCNT      RWD DELAY DEPENDING ON REC CNT
1403           BWZ  TAPE6E,T6WCNT,K    TIME TO REWIND?
1411           LCA  RDELAY,T6RCNT      DELAY FOR FULL REEL REWIND
1418           BEF  TAPE6E
1423           LCA  KM1,T6RCNT         SET FOR NO REWIND DELAY
1430 TAPE6W    MCW  %U6,GMWM,W
1438           S    KP1,T6WCNT         DECREMENT WRITE COUNTER
1445           MCW  T6PMAX,T6PCNT      STORE PROCESSING DELAY
1452 TAPE6X    B    0
1456 TAPE6E    CU   %U6,R
1461           MCW  T6WMAX,T6WCNT      RE-INITIALIZE WRITE COUNT
1468           B    TAPE6X
     *  
1472 T6PMAX    DCW  00
1474 T6PCNT    DCW  01
1476 T6WMAX    DCW  000                MAX RECORDS TO WRITE UNTIL REWIND
1479 T6WCNT    DCW  100                RECORDS TO WRITE UNTIL REWIND
1482 T6RDLY    DCW  0000               DELAY FOR REWIND
1486 T6RCNT    DCW  -0001              COUNT WHILE REWINDING
     *
1490 RDELAY    DCW  0000               DELAY COUNTER FOR EOT REWINDS
1494 KM1       DCW  -0001              CONSTANT -1
     *
1498 P16K      DCW  &16000
1503 KP1       DCW  &1                 CONSTANT +1
1504 KS        DCW  @S@                CONSTANT S TO CHANGE BSS TO BE
1505 KC        DCW  @C@                CONSTANT C TO CHANGE BE TO BSS
               DS   4000
     GMWM      DCW  @"@
     IMAGE     DS   1
               END  START
